import React from 'react';
import './CustomDropDown.css';
interface Props {
    /**
     * A multiple choices list
     */
    multipleSelect?: boolean | undefined;
    /**
     * The select options must be [{displayName:'name', value:'value'}] format
     */
    options: any[];
    /**
     * The placeholder text for the select input
     */
    textbarPlaceHolder?: string;
    /**
     * Adding a class name to style select input
     */
    textbarStyle?: string;
    /**
     * Adding a class name to style search bar
     */
    searchbarStyle?: string;
    /**
     * Adding a class name to style dropdown menu
     */
    styleDropDownMenu?: string;
    /**
     * Selected values variable (stateful value)
     */
    selectedValues: any;
    /**
     * A UseState function to update selectedValues variable
     */
    setSelectedValues: React.Dispatch<React.SetStateAction<any>>;
}
declare const CustomDropDown: ({ multipleSelect, options, textbarPlaceHolder, textbarStyle, searchbarStyle, styleDropDownMenu, selectedValues, setSelectedValues, }: Props) => React.JSX.Element | undefined;
export default CustomDropDown;
