"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
require("./CustomDropDown.css");
const CustomDropDown = ({ multipleSelect, options, textbarPlaceHolder, textbarStyle, searchbarStyle, styleDropDownMenu, selectedValues, setSelectedValues, }) => {
    if (!options || options == undefined) {
        console.error("You are missing options props, and it must be [{displayName:'name', value:'value'}] format");
        return;
    }
    if (!selectedValues) {
        console.error("You are missing selectedValues props, a selected values variable (stateful value)");
        return;
    }
    if (!setSelectedValues) {
        console.error("You are missing setSelectedValues props, a UseState function to update selectedValues variable");
        return;
    }
    const [searchTerm, setSearchTerm] = (0, react_1.useState)('');
    const [isOpen, setIsOpen] = (0, react_1.useState)(false);
    const [filteredOptions, setFilteredOptions] = (0, react_1.useState)(options);
    const [displayName, setDisplayName] = (0, react_1.useState)([]);
    const dropdownRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        const handleClickOutside = (event) => {
            if (dropdownRef.current && !dropdownRef.current.contains(event.target)) {
                setIsOpen(false);
                setSearchTerm('');
                setFilteredOptions(options);
            }
        };
        document.addEventListener('mousedown', handleClickOutside);
        return () => {
            document.removeEventListener('mousedown', handleClickOutside);
        };
    }, []);
    const handleCheckboxChange = (option) => {
        if (selectedValues.some((_option) => _option.displayName === option.displayName &&
            _option.value === option.value)) {
            setSelectedValues(selectedValues.filter((item) => item.displayName !== option.displayName &&
                item.value !== option.value));
            setDisplayName(selectedValues.filter((item) => item !== option).displayName || []);
        }
        else {
            setSelectedValues([...selectedValues, option]);
            setDisplayName([...displayName, option.displayName]);
        }
    };
    const handleInputChange = (event) => {
        const term = event.target.value;
        setSearchTerm(term);
        const filtered = options.filter((option) => { var _a; return (_a = option.displayName) === null || _a === void 0 ? void 0 : _a.toLowerCase().includes(term.toLowerCase()); });
        setFilteredOptions(filtered);
    };
    const toggleDropdown = () => {
        setIsOpen(false);
    };
    const handleOptionClick = (option) => {
        setSelectedValues(option);
        toggleDropdown();
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, multipleSelect ? (react_1.default.createElement("div", { className: "dropdown", ref: dropdownRef },
        react_1.default.createElement("input", { type: "text", placeholder: textbarPlaceHolder || 'Select...', value: [...selectedValues]
                .map((item) => item === null || item === void 0 ? void 0 : item.displayName)
                .join(', '), onFocus: () => setIsOpen(true), className: textbarStyle, readOnly: true }),
        isOpen && (react_1.default.createElement("ul", { className: `${styleDropDownMenu} options` },
            react_1.default.createElement("input", { className: `search-bar ${searchbarStyle}`, type: "text", placeholder: "Search...", value: searchTerm, onChange: handleInputChange }),
            filteredOptions.map((option, index) => (react_1.default.createElement("li", { key: index, onClick: () => handleCheckboxChange(option) },
                react_1.default.createElement("input", { type: "checkbox", value: option, checked: selectedValues.some((_option) => _option.displayName === option.displayName &&
                        _option.value === option.value), readOnly: true }),
                react_1.default.createElement("label", { htmlFor: option.displayName }, option.displayName)))))))) : (react_1.default.createElement("div", { className: "dropdown", ref: dropdownRef },
        react_1.default.createElement("input", { type: "text", placeholder: textbarPlaceHolder || 'Select...', value: (selectedValues === null || selectedValues === void 0 ? void 0 : selectedValues.displayName) || '', onFocus: () => setIsOpen(true), className: textbarStyle, readOnly: true }),
        isOpen && (react_1.default.createElement("ul", { className: `${styleDropDownMenu} options` },
            react_1.default.createElement("input", { className: `search-bar ${searchbarStyle}`, type: "text", placeholder: "Search...", value: searchTerm, onChange: handleInputChange }),
            filteredOptions.map((option, index) => (react_1.default.createElement("li", { key: index, onClick: () => handleOptionClick(option) }, option.displayName)))))))));
};
exports.default = CustomDropDown;
